/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the LevelOfAssurance type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LevelOfAssurance{}

// LevelOfAssurance struct for LevelOfAssurance
type LevelOfAssurance struct {
	Value        int32          `json:"value"`
	DisplayName  string         `json:"displayName"`
	Description  string         `json:"description"`
	Id           NullableString `json:"id,omitempty"`
	CreationTime *time.Time     `json:"creationTime,omitempty"`
}

type _LevelOfAssurance LevelOfAssurance

// NewLevelOfAssurance instantiates a new LevelOfAssurance object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLevelOfAssurance(value int32, displayName string, description string) *LevelOfAssurance {
	this := LevelOfAssurance{}
	this.Value = value
	this.DisplayName = displayName
	this.Description = description
	return &this
}

// NewLevelOfAssuranceWithDefaults instantiates a new LevelOfAssurance object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLevelOfAssuranceWithDefaults() *LevelOfAssurance {
	this := LevelOfAssurance{}
	return &this
}

// GetValue returns the Value field value
func (o *LevelOfAssurance) GetValue() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Value
}

// GetValueOk returns a tuple with the Value field value
// and a boolean to check if the value has been set.
func (o *LevelOfAssurance) GetValueOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Value, true
}

// SetValue sets field value
func (o *LevelOfAssurance) SetValue(v int32) {
	o.Value = v
}

// GetDisplayName returns the DisplayName field value
func (o *LevelOfAssurance) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *LevelOfAssurance) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *LevelOfAssurance) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetDescription returns the Description field value
func (o *LevelOfAssurance) GetDescription() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Description
}

// GetDescriptionOk returns a tuple with the Description field value
// and a boolean to check if the value has been set.
func (o *LevelOfAssurance) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Description, true
}

// SetDescription sets field value
func (o *LevelOfAssurance) SetDescription(v string) {
	o.Description = v
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *LevelOfAssurance) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *LevelOfAssurance) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *LevelOfAssurance) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *LevelOfAssurance) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *LevelOfAssurance) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *LevelOfAssurance) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *LevelOfAssurance) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LevelOfAssurance) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *LevelOfAssurance) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *LevelOfAssurance) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o LevelOfAssurance) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LevelOfAssurance) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["value"] = o.Value
	toSerialize["displayName"] = o.DisplayName
	toSerialize["description"] = o.Description
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *LevelOfAssurance) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"value",
		"displayName",
		"description",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varLevelOfAssurance := _LevelOfAssurance{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varLevelOfAssurance)

	if err != nil {
		return err
	}

	*o = LevelOfAssurance(varLevelOfAssurance)

	return err
}

type NullableLevelOfAssurance struct {
	value *LevelOfAssurance
	isSet bool
}

func (v NullableLevelOfAssurance) Get() *LevelOfAssurance {
	return v.value
}

func (v *NullableLevelOfAssurance) Set(val *LevelOfAssurance) {
	v.value = val
	v.isSet = true
}

func (v NullableLevelOfAssurance) IsSet() bool {
	return v.isSet
}

func (v *NullableLevelOfAssurance) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLevelOfAssurance(val *LevelOfAssurance) *NullableLevelOfAssurance {
	return &NullableLevelOfAssurance{value: val, isSet: true}
}

func (v NullableLevelOfAssurance) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLevelOfAssurance) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
